# HttpURLConnection

public abstract class **HttpURLConnection** extends [URLConnection](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html)  

|---|---|---|
| Known Direct Subclasses [HttpsURLConnection](https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/HttpsURLConnection.html) |---|---| | [HttpsURLConnection](https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/HttpsURLConnection.html) | `HttpsURLConnection` extends `HttpURLConnection` with support for https-specific features. | |||

A URLConnection with support for HTTP-specific features. See
[the spec](http://www.w3.org/pub/WWW/Protocols/) for
details.


Uses of this class follow a pattern:

1. Obtain a new `HttpURLConnection` by calling `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URL.html#openConnection()` and casting the result to `HttpURLConnection`.
2. Prepare the request. The primary property of a request is its URI. Request headers may also include metadata such as credentials, preferred content types, and session cookies.
3. Optionally upload a request body. Instances must be configured with `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDoOutput(boolean)` if they include a request body. Transmit data by writing to the stream returned by `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getOutputStream()`.
4. Read the response. Response headers typically include metadata such as the response body's content type and length, modified dates and session cookies. The response body may be read from the stream returned by `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getInputStream()`. If the response has no body, that method returns an empty stream.
5. Disconnect. Once the response body has been read, the `HttpURLConnection` should be closed by calling `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#disconnect()`. Disconnecting releases the resources held by a connection so they may be closed or reused.

For example, to retrieve the webpage at `http://www.android.com/`:

       URL url = new URL("http://www.android.com/");
       HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
       try {
         InputStream in = new BufferedInputStream(urlConnection.getInputStream());
         readStream(in);
       } finally {
         urlConnection.disconnect();
       }
     
### Secure Communication with HTTPS

Calling `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URL.html#openConnection()` on a URL with the "https" scheme will return an `HttpsURLConnection`, which allows for overriding the default `https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/HostnameVerifier.html` and `https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/SSLSocketFactory.html`. An application-supplied `SSLSocketFactory` created from an `https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/SSLContext.html` can provide a custom `https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/X509TrustManager.html` for verifying certificate chains and a custom `https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/X509KeyManager.html` for supplying client certificates. See `https://developers.google.com/j2objc/javadoc/jre/reference/javax/net/ssl/HttpsURLConnection.html` for more details.

### Response Handling

`HttpURLConnection` will follow up to five HTTP redirects. It will follow redirects from one origin server to another. This implementation doesn't follow redirects from HTTPS to HTTP or vice versa.

If the HTTP response indicates that an error occurred, `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getInputStream()` will throw an `https://developers.google.com/j2objc/javadoc/jre/reference/java/io/IOException.html`. Use `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getErrorStream()` to read the error response. The headers can be read in
the normal way using `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderFields()`,

### Posting Content

To upload data to a web server, configure the connection for output using `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDoOutput(boolean)`.

For best performance, you should call either `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFixedLengthStreamingMode(int)` when the body length is known in advance,
or `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setChunkedStreamingMode(int)` when it is not. Otherwise `HttpURLConnection` will be forced to buffer the complete request body in
memory before it is transmitted, wasting (and possibly exhausting) heap and
increasing latency.

For example, to perform an upload:

       HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
       try {
         urlConnection.setDoOutput(true);
         urlConnection.setChunkedStreamingMode(0);

         OutputStream out = new BufferedOutputStream(urlConnection.getOutputStream());
         writeStream(out);

         InputStream in = new BufferedInputStream(urlConnection.getInputStream());
         readStream(in);
       } finally {
         urlConnection.disconnect();
       }
     
### Performance

The input and output streams returned by this class are **not
buffered** . Most callers should wrap the returned streams with `https://developers.google.com/j2objc/javadoc/jre/reference/java/io/BufferedInputStream.html` or `https://developers.google.com/j2objc/javadoc/jre/reference/java/io/BufferedOutputStream.html`. Callers that do only bulk reads or writes may omit buffering.

When transferring large amounts of data to or from a server, use streams
to limit how much data is in memory at once. Unless you need the entire
body to be in memory at once, process it as a stream (rather than storing
the complete body as a single byte array or string).

To reduce latency, this class may reuse the same underlying `Socket`
for multiple request/response pairs. As a result, HTTP connections may be
held open longer than necessary. Calls to `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#disconnect()` may return
the socket to a pool of connected sockets.

By default, this implementation of `HttpURLConnection` requests that
servers use gzip compression and it automatically decompresses the data for
callers of `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getInputStream()`. The Content-Encoding and Content-Length
response headers are cleared in this case. Gzip compression can be disabled by
setting the acceptable encodings in the request header:

       urlConnection.setRequestProperty("Accept-Encoding", "identity");
     
Setting the Accept-Encoding request header explicitly disables automatic
decompression and leaves the response headers intact; callers must handle
decompression as needed, according to the Content-Encoding header of the
response.

`https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getContentLength()` returns the number of bytes transmitted and
cannot be used to predict how many bytes can be read from
`https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getInputStream()` for compressed streams. Instead, read that stream
until it is exhausted, i.e. when `https://developers.google.com/j2objc/javadoc/jre/reference/java/io/InputStream.html#read()` returns -1.

### Handling Network Sign-On

Some Wi-Fi networks block Internet access until the user clicks through a sign-on page. Such sign-on pages are typically presented by using HTTP redirects. You can use `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getURL()` to test if your connection has been unexpectedly redirected. This check is not valid until **after** the response headers have been received, which you can trigger by calling `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderFields()` or `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getInputStream()`. For example, to check that a response was not redirected to an unexpected host:

       HttpURLConnection urlConnection = (HttpURLConnection) url.openConnection();
       try {
         InputStream in = new BufferedInputStream(urlConnection.getInputStream());
         if (!url.getHost().equals(urlConnection.getURL().getHost())) {
           // we were redirected! Kick the user out to the browser to sign on?
         }
         ...
       } finally {
         urlConnection.disconnect();
       }
     
### HTTP Authentication

`HttpURLConnection` supports [HTTP basic authentication](http://www.ietf.org/rfc/rfc2617). Use `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/Authenticator.html` to set the VM-wide authentication handler:

       Authenticator.setDefault(new Authenticator() {
         protected PasswordAuthentication getPasswordAuthentication() {
           return new PasswordAuthentication(username, password.toCharArray());
         }
       });
     
Unless paired with HTTPS, this is **not** a secure mechanism for user authentication. In particular, the username, password, request and response are all transmitted over the network without encryption.

### Sessions with Cookies

To establish and maintain a potentially long-lived session between client and server, `HttpURLConnection` includes an extensible cookie manager. Enable VM-wide cookie management using `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/CookieHandler.html` and `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/CookieManager.html`:

       CookieManager cookieManager = new CookieManager();
       CookieHandler.setDefault(cookieManager);
     
By default, `CookieManager` accepts cookies from the [origin
server](http://www.w3.org/Protocols/rfc2616/rfc2616-sec1.html) only. Two other policies are included: `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/CookiePolicy.html#ACCEPT_ALL` and `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/CookiePolicy.html#ACCEPT_NONE`. Implement `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/CookiePolicy.html` to define a custom policy.

The default `CookieManager` keeps all accepted cookies in memory. It
will forget these cookies when the VM exits. Implement `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/CookieStore.html` to
define a custom cookie store.

In addition to the cookies set by HTTP responses, you may set cookies
programmatically. To be included in HTTP request headers, cookies must have
the domain and path properties set.

By default, new instances of `HttpCookie` work only with servers
that support [RFC 2965](http://www.ietf.org/rfc/rfc2965.txt)
cookies. Many web servers support only the older specification, [RFC 2109](http://www.ietf.org/rfc/rfc2109.txt). For compatibility
with the most web servers, set the cookie version to 0.

For example, to receive `www.twitter.com` in French:

       HttpCookie cookie = new HttpCookie("lang", "fr");
       cookie.setDomain("twitter.com");
       cookie.setPath("/");
       cookie.setVersion(0);
       cookieManager.getCookieStore().add(new URI("http://twitter.com/"), cookie);
     
### HTTP Methods

`HttpURLConnection` uses the `GET` method by default. It will
use `POST` if `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDoOutput(boolean)` has been called.
Other HTTP methods (`OPTIONS`, `HEAD`, `PUT`, `DELETE` and `TRACE`) can be used with `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setRequestMethod(java.lang.String)`.

### Proxies

By default, this class will connect directly to the [origin
server](http://www.w3.org/Protocols/rfc2616/rfc2616-sec1.html). It can also connect via an `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/Proxy.Type.html#HTTP` or `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/Proxy.Type.html#SOCKS` proxy. To use a proxy, use `https://developers.google.com/j2objc/javadoc/jre/` when creating the connection.

### IPv6 Support

This class includes transparent support for IPv6. For hosts with both IPv4
and IPv6 addresses, it will attempt to connect to each of a host's addresses
until a connection is established.

### Response Caching

Android 4.0 (Ice Cream Sandwich, API level 15) includes a response cache. See `android.net.http.HttpResponseCache` for instructions on enabling HTTP caching in your application.

### Avoiding Bugs In Earlier Releases

Prior to Android 2.2 (Froyo), this class had some frustrating bugs. In particular, calling `close()` on a readable `InputStream` could [poison the
connection pool](http://code.google.com/p/android/issues/detail?id=2939). Work around this by disabling connection pooling:

       private void disableConnectionReuseIfNecessary() {
       // Work around pre-Froyo bugs in HTTP connection reuse.
       if (Integer.parseInt(Build.VERSION.SDK) < Build.VERSION_CODES.FROYO) {
         System.setProperty("http.keepAlive", "false");
       }
     }

Each instance of `HttpURLConnection` may be used for one
request/response pair. Instances of this class are not thread safe.

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#disconnect()`

### Constant Summary

|---|---|---|
| int | [HTTP_ACCEPTED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_ACCEPTED) | HTTP Status-Code 202: Accepted. |
| int | [HTTP_BAD_GATEWAY](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_BAD_GATEWAY) | HTTP Status-Code 502: Bad Gateway. |
| int | [HTTP_BAD_METHOD](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_BAD_METHOD) | HTTP Status-Code 405: Method Not Allowed. |
| int | [HTTP_BAD_REQUEST](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_BAD_REQUEST) | HTTP Status-Code 400: Bad Request. |
| int | [HTTP_CLIENT_TIMEOUT](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_CLIENT_TIMEOUT) | HTTP Status-Code 408: Request Time-Out. |
| int | [HTTP_CONFLICT](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_CONFLICT) | HTTP Status-Code 409: Conflict. |
| int | [HTTP_CREATED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_CREATED) | HTTP Status-Code 201: Created. |
| int | [HTTP_ENTITY_TOO_LARGE](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_ENTITY_TOO_LARGE) | HTTP Status-Code 413: Request Entity Too Large. |
| int | [HTTP_FORBIDDEN](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_FORBIDDEN) | HTTP Status-Code 403: Forbidden. |
| int | [HTTP_GATEWAY_TIMEOUT](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_GATEWAY_TIMEOUT) | HTTP Status-Code 504: Gateway Timeout. |
| int | [HTTP_GONE](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_GONE) | HTTP Status-Code 410: Gone. |
| int | [HTTP_INTERNAL_ERROR](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_INTERNAL_ERROR) | HTTP Status-Code 500: Internal Server Error. |
| int | [HTTP_LENGTH_REQUIRED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_LENGTH_REQUIRED) | HTTP Status-Code 411: Length Required. |
| int | [HTTP_MOVED_PERM](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_MOVED_PERM) | HTTP Status-Code 301: Moved Permanently. |
| int | [HTTP_MOVED_TEMP](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_MOVED_TEMP) | HTTP Status-Code 302: Temporary Redirect. |
| int | [HTTP_MULT_CHOICE](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_MULT_CHOICE) | HTTP Status-Code 300: Multiple Choices. |
| int | [HTTP_NOT_ACCEPTABLE](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_NOT_ACCEPTABLE) | HTTP Status-Code 406: Not Acceptable. |
| int | [HTTP_NOT_AUTHORITATIVE](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_NOT_AUTHORITATIVE) | HTTP Status-Code 203: Non-Authoritative Information. |
| int | [HTTP_NOT_FOUND](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_NOT_FOUND) | HTTP Status-Code 404: Not Found. |
| int | [HTTP_NOT_IMPLEMENTED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_NOT_IMPLEMENTED) | HTTP Status-Code 501: Not Implemented. |
| int | [HTTP_NOT_MODIFIED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_NOT_MODIFIED) | HTTP Status-Code 304: Not Modified. |
| int | [HTTP_NO_CONTENT](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_NO_CONTENT) | HTTP Status-Code 204: No Content. |
| int | [HTTP_OK](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_OK) | HTTP Status-Code 200: OK. |
| int | [HTTP_PARTIAL](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_PARTIAL) | HTTP Status-Code 206: Partial Content. |
| int | [HTTP_PAYMENT_REQUIRED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_PAYMENT_REQUIRED) | HTTP Status-Code 402: Payment Required. |
| int | [HTTP_PRECON_FAILED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_PRECON_FAILED) | HTTP Status-Code 412: Precondition Failed. |
| int | [HTTP_PROXY_AUTH](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_PROXY_AUTH) | HTTP Status-Code 407: Proxy Authentication Required. |
| int | [HTTP_REQ_TOO_LONG](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_REQ_TOO_LONG) | HTTP Status-Code 414: Request-URI Too Large. |
| int | [HTTP_RESET](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_RESET) | HTTP Status-Code 205: Reset Content. |
| int | [HTTP_SEE_OTHER](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_SEE_OTHER) | HTTP Status-Code 303: See Other. |
| int | [HTTP_SERVER_ERROR](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_SERVER_ERROR) | *This constant is deprecated. it is misplaced and shouldn't have existed.* |
| int | [HTTP_UNAUTHORIZED](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_UNAUTHORIZED) | HTTP Status-Code 401: Unauthorized. |
| int | [HTTP_UNAVAILABLE](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_UNAVAILABLE) | HTTP Status-Code 503: Service Unavailable. |
| int | [HTTP_UNSUPPORTED_TYPE](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_UNSUPPORTED_TYPE) | HTTP Status-Code 415: Unsupported Media Type. |
| int | [HTTP_USE_PROXY](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_USE_PROXY) | HTTP Status-Code 305: Use Proxy. |
| int | [HTTP_VERSION](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HTTP_VERSION) | HTTP Status-Code 505: HTTP Version Not Supported. |

### Field Summary

|---|---|---|
| protected int | [chunkLength](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#chunkLength) | The chunk-length when using chunked encoding streaming mode for output. |
| protected int | [fixedContentLength](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#fixedContentLength) | The fixed content-length when using fixed-length streaming mode. |
| protected long | [fixedContentLengthLong](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#fixedContentLengthLong) | The fixed content-length when using fixed-length streaming mode. |
| protected boolean | [instanceFollowRedirects](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#instanceFollowRedirects) | If `true`, the protocol will automatically follow redirects. |
| protected [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [method](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#method) | The HTTP method (GET,POST,PUT,etc.). |
| protected int | [responseCode](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#responseCode) | An `int` representing the three digit HTTP Status-Code. |
| protected [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [responseMessage](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#responseMessage) | The HTTP response message. |

### Inherited Field Summary

From class [java.net.URLConnection](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html)

|---|---|---|
| protected boolean | [allowUserInteraction](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#allowUserInteraction) | If `true`, this `URL` is being examined in a context in which it makes sense to allow user interactions such as popping up an authentication dialog. |
| protected boolean | [connected](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#connected) | If `false`, this connection object has not created a communications link to the specified URL. |
| protected boolean | [doInput](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#doInput) | This variable is set by the `setDoInput` method. |
| protected boolean | [doOutput](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#doOutput) | This variable is set by the `setDoOutput` method. |
| protected long | [ifModifiedSince](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#ifModifiedSince) | Some protocols support skipping the fetching of the object unless the object has been modified more recently than a certain time. |
| protected [URL](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URL.html) | [url](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#url) | The URL represents the remote object on the World Wide Web to which this connection is opened. |
| protected boolean | [useCaches](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#useCaches) | If `true`, the protocol is allowed to use caching whenever it can. |

### Protected Constructor Summary

|---|---|
|   | [HttpURLConnection](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#HttpURLConnection(java.net.URL))([URL](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URL.html) u) Constructor for the HttpURLConnection. |

### Public Method Summary

|---|---|
| abstract void | [disconnect](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#disconnect())() Indicates that other requests to the server are unlikely in the near future. |
| [InputStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/InputStream.html) | [getErrorStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getErrorStream())() Returns the error stream if the connection failed but the server sent useful data nonetheless. |
| static boolean | [getFollowRedirects](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getFollowRedirects())() Returns a `boolean` indicating whether or not HTTP redirects (3xx) should be automatically followed. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getHeaderField](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getHeaderField(int))(int n) Returns the value for the `n`^th^ header field. |
| long | [getHeaderFieldDate](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getHeaderFieldDate(java.lang.String,%20long))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) name, long Default) Returns the value of the named field parsed as date. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getHeaderFieldKey](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getHeaderFieldKey(int))(int n) Returns the key for the `n`^th^ header field. |
| boolean | [getInstanceFollowRedirects](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getInstanceFollowRedirects())() Returns the value of this `HttpURLConnection`'s `instanceFollowRedirects` field. |
| [Permission](https://developers.google.com/j2objc/javadoc/jre/reference/java/security/Permission.html) | [getPermission](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getPermission())() Returns a `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/SocketPermission.html` object representing the permission necessary to connect to the destination host and port. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getRequestMethod](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getRequestMethod())() Get the request method. |
| int | [getResponseCode](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getResponseCode())() Gets the status code from an HTTP response message. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getResponseMessage](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getResponseMessage())() Gets the HTTP response message, if any, returned along with the response code from a server. |
| void | [setChunkedStreamingMode](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setChunkedStreamingMode(int))(int chunklen) This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is **not** known in advance. |
| void | [setFixedLengthStreamingMode](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFixedLengthStreamingMode(int))(int contentLength) This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is known in advance. |
| void | [setFixedLengthStreamingMode](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFixedLengthStreamingMode(long))(long contentLength) This method is used to enable streaming of a HTTP request body without internal buffering, when the content length is known in advance. |
| static void | [setFollowRedirects](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFollowRedirects(boolean))(boolean set) Sets whether HTTP redirects (requests with response code 3xx) should be automatically followed by this class. |
| void | [setInstanceFollowRedirects](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setInstanceFollowRedirects(boolean))(boolean followRedirects) Sets whether HTTP redirects (requests with response code 3xx) should be automatically followed by this `HttpURLConnection` instance. |
| void | [setRequestMethod](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setRequestMethod(java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) method) Set the method for the URL request, one of: - GET - POST - HEAD - OPTIONS - PUT - DELETE - TRACE are legal, subject to protocol restrictions. |
| abstract boolean | [usingProxy](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#usingProxy())() Indicates if the connection is going through a proxy. |

### Inherited Method Summary

From class [java.net.URLConnection](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html)

|---|---|
| void | [addRequestProperty](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#addRequestProperty(java.lang.String,%20java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) key, [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) value) Adds a general request property specified by a key-value pair. |
| abstract void | [connect](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#connect())() Opens a communications link to the resource referenced by this URL, if such a connection has not already been established. |
| boolean | [getAllowUserInteraction](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getAllowUserInteraction())() Returns the value of the `allowUserInteraction` field for this object. |
| int | [getConnectTimeout](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getConnectTimeout())() Returns setting for connect timeout. |
| [Object](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html) | [getContent](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getContent())() Retrieves the contents of this URL connection. |
| [Object](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html) | [getContent](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getContent(java.lang.Class[]))([Class\[\]](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Class.html) classes) Retrieves the contents of this URL connection. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getContentEncoding](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getContentEncoding())() Returns the value of the `content-encoding` header field. |
| int | [getContentLength](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getContentLength())() Returns the value of the `content-length` header field. |
| long | [getContentLengthLong](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getContentLengthLong())() Returns the value of the `content-length` header field as a long. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getContentType](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getContentType())() Returns the value of the `content-type` header field. |
| long | [getDate](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getDate())() Returns the value of the `date` header field. |
| static boolean | [getDefaultAllowUserInteraction](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getDefaultAllowUserInteraction())() Returns the default value of the `allowUserInteraction` field. |
| static [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getDefaultRequestProperty](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getDefaultRequestProperty(java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) key) *This method is deprecated. The instance specific getRequestProperty method should be used after an appropriate instance of URLConnection is obtained.* |
| boolean | [getDefaultUseCaches](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getDefaultUseCaches())() Returns the default value of a `URLConnection`'s `useCaches` flag. |
| boolean | [getDoInput](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getDoInput())() Returns the value of this `URLConnection`'s `doInput` flag. |
| boolean | [getDoOutput](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getDoOutput())() Returns the value of this `URLConnection`'s `doOutput` flag. |
| long | [getExpiration](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getExpiration())() Returns the value of the `expires` header field. |
| synchronized static [FileNameMap](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/FileNameMap.html) | [getFileNameMap](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getFileNameMap())() Returns a `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/FileNameMap.html` implementation suitable for guessing a content type based on a URL's "file" component. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getHeaderField](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderField(java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) name) Returns the value of the named header field. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getHeaderField](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderField(int))(int n) Returns the value for the `n`^th^ header field. |
| long | [getHeaderFieldDate](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderFieldDate(java.lang.String,%20long))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) name, long Default) Returns the value of the named field parsed as date. |
| int | [getHeaderFieldInt](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderFieldInt(java.lang.String,%20int))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) name, int Default) Returns the value of the named field parsed as a number. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getHeaderFieldKey](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderFieldKey(int))(int n) Returns the key for the `n`^th^ header field. |
| long | [getHeaderFieldLong](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderFieldLong(java.lang.String,%20long))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) name, long Default) Returns the value of the named field parsed as a number. |
| [Map](https://developers.google.com/j2objc/javadoc/jre/reference/java/util/Map.html)\<[String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html), [List](https://developers.google.com/j2objc/javadoc/jre/reference/java/util/List.html)\<[String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)\>\> | [getHeaderFields](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getHeaderFields())() Returns an unmodifiable Map of the header fields. |
| long | [getIfModifiedSince](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getIfModifiedSince())() Returns the value of this object's `ifModifiedSince` field. |
| [InputStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/InputStream.html) | [getInputStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getInputStream())() Returns an input stream that reads from this open connection. |
| long | [getLastModified](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getLastModified())() Returns the value of the `last-modified` header field. |
| [OutputStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/OutputStream.html) | [getOutputStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getOutputStream())() Returns an output stream that writes to this connection. |
| [Permission](https://developers.google.com/j2objc/javadoc/jre/reference/java/security/Permission.html) | [getPermission](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getPermission())() Returns a permission object representing the permission necessary to make the connection represented by this object. |
| int | [getReadTimeout](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getReadTimeout())() Returns setting for read timeout. |
| [Map](https://developers.google.com/j2objc/javadoc/jre/reference/java/util/Map.html)\<[String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html), [List](https://developers.google.com/j2objc/javadoc/jre/reference/java/util/List.html)\<[String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)\>\> | [getRequestProperties](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getRequestProperties())() Returns an unmodifiable Map of general request properties for this connection. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [getRequestProperty](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getRequestProperty(java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) key) Returns the value of the named general request property for this connection. |
| [URL](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URL.html) | [getURL](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getURL())() Returns the value of this `URLConnection`'s `URL` field. |
| boolean | [getUseCaches](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#getUseCaches())() Returns the value of this `URLConnection`'s `useCaches` field. |
| static [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [guessContentTypeFromName](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#guessContentTypeFromName(java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) fname) Tries to determine the content type of an object, based on the specified "file" component of a URL. |
| static [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [guessContentTypeFromStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#guessContentTypeFromStream(java.io.InputStream))([InputStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/InputStream.html) is) Tries to determine the type of an input stream based on the characters at the beginning of the input stream. |
| void | [setAllowUserInteraction](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setAllowUserInteraction(boolean))(boolean allowuserinteraction) Set the value of the `allowUserInteraction` field of this `URLConnection`. |
| void | [setConnectTimeout](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setConnectTimeout(int))(int timeout) Sets a specified timeout value, in milliseconds, to be used when opening a communications link to the resource referenced by this URLConnection. |
| synchronized static void | [setContentHandlerFactory](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setContentHandlerFactory(java.net.ContentHandlerFactory))([ContentHandlerFactory](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/ContentHandlerFactory.html) fac) Sets the `ContentHandlerFactory` of an application. |
| static void | [setDefaultAllowUserInteraction](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDefaultAllowUserInteraction(boolean))(boolean defaultallowuserinteraction) Sets the default value of the `allowUserInteraction` field for all future `URLConnection` objects to the specified value. |
| static void | [setDefaultRequestProperty](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDefaultRequestProperty(java.lang.String,%20java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) key, [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) value) *This method is deprecated. The instance specific setRequestProperty method should be used after an appropriate instance of URLConnection is obtained. Invoking this method will have no effect.* |
| void | [setDefaultUseCaches](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDefaultUseCaches(boolean))(boolean defaultusecaches) Sets the default value of the `useCaches` field to the specified value. |
| void | [setDoInput](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDoInput(boolean))(boolean doinput) Sets the value of the `doInput` field for this `URLConnection` to the specified value. |
| void | [setDoOutput](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setDoOutput(boolean))(boolean dooutput) Sets the value of the `doOutput` field for this `URLConnection` to the specified value. |
| static void | [setFileNameMap](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setFileNameMap(java.net.FileNameMap))([FileNameMap](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/FileNameMap.html) map) Sets the FileNameMap. |
| void | [setIfModifiedSince](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setIfModifiedSince(long))(long ifmodifiedsince) Sets the value of the `ifModifiedSince` field of this `URLConnection` to the specified value. |
| void | [setReadTimeout](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setReadTimeout(int))(int timeout) Sets the read timeout to a specified timeout, in milliseconds. |
| void | [setRequestProperty](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setRequestProperty(java.lang.String,%20java.lang.String))([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) key, [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) value) Sets the general request property. |
| void | [setUseCaches](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#setUseCaches(boolean))(boolean usecaches) Sets the value of the `useCaches` field of this `URLConnection` to the specified value. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [toString](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URLConnection.html#toString())() Returns a `String` representation of this URL connection. |

From class [java.lang.Object](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html)

|---|---|
| [Object](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html) | [clone](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#clone())() Creates and returns a copy of this `Object`. |
| boolean | [equals](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#equals(java.lang.Object))([Object](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html) obj) Compares this instance with the specified object and indicates if they are equal. |
| void | [finalize](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#finalize())() Invoked when the garbage collector has detected that this instance is no longer reachable. |
| final [Class](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Class.html)\<?\> | [getClass](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#getClass())() Returns the unique instance of `https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Class.html` that represents this object's class. |
| int | [hashCode](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#hashCode())() Returns an integer hash code for this object. |
| final void | [notify](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#notify())() Causes a thread which is waiting on this object's monitor (by means of calling one of the `wait()` methods) to be woken up. |
| final void | [notifyAll](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#notifyAll())() Causes all threads which are waiting on this object's monitor (by means of calling one of the `wait()` methods) to be woken up. |
| [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) | [toString](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#toString())() Returns a string containing a concise, human-readable description of this object. |
| final void | [wait](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#wait(long,%20int))(long timeout, int nanos) Causes the calling thread to wait until another thread calls the `notify()` or `notifyAll()` method of this object or until the specified timeout expires. |
| final void | [wait](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#wait(long))(long timeout) Causes the calling thread to wait until another thread calls the `notify()` or `notifyAll()` method of this object or until the specified timeout expires. |
| final void | [wait](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/Object.html#wait())() Causes the calling thread to wait until another thread calls the `notify()` or `notifyAll()` method of this object. |

## Constants

#### public static final int
**HTTP_ACCEPTED**

HTTP Status-Code 202: Accepted.
Constant Value: 202

#### public static final int
**HTTP_BAD_GATEWAY**

HTTP Status-Code 502: Bad Gateway.
Constant Value: 502

#### public static final int
**HTTP_BAD_METHOD**

HTTP Status-Code 405: Method Not Allowed.
Constant Value: 405

#### public static final int
**HTTP_BAD_REQUEST**

HTTP Status-Code 400: Bad Request.
Constant Value: 400

#### public static final int
**HTTP_CLIENT_TIMEOUT**

HTTP Status-Code 408: Request Time-Out.
Constant Value: 408

#### public static final int
**HTTP_CONFLICT**

HTTP Status-Code 409: Conflict.
Constant Value: 409

#### public static final int
**HTTP_CREATED**

HTTP Status-Code 201: Created.
Constant Value: 201

#### public static final int
**HTTP_ENTITY_TOO_LARGE**

HTTP Status-Code 413: Request Entity Too Large.
Constant Value: 413

#### public static final int
**HTTP_FORBIDDEN**

HTTP Status-Code 403: Forbidden.
Constant Value: 403

#### public static final int
**HTTP_GATEWAY_TIMEOUT**

HTTP Status-Code 504: Gateway Timeout.
Constant Value: 504

#### public static final int
**HTTP_GONE**

HTTP Status-Code 410: Gone.
Constant Value: 410

#### public static final int
**HTTP_INTERNAL_ERROR**

HTTP Status-Code 500: Internal Server Error.
Constant Value: 500

#### public static final int
**HTTP_LENGTH_REQUIRED**

HTTP Status-Code 411: Length Required.
Constant Value: 411

#### public static final int
**HTTP_MOVED_PERM**

HTTP Status-Code 301: Moved Permanently.
Constant Value: 301

#### public static final int
**HTTP_MOVED_TEMP**

HTTP Status-Code 302: Temporary Redirect.
Constant Value: 302

#### public static final int
**HTTP_MULT_CHOICE**

HTTP Status-Code 300: Multiple Choices.
Constant Value: 300

#### public static final int
**HTTP_NOT_ACCEPTABLE**

HTTP Status-Code 406: Not Acceptable.
Constant Value: 406

#### public static final int
**HTTP_NOT_AUTHORITATIVE**

HTTP Status-Code 203: Non-Authoritative Information.
Constant Value: 203

#### public static final int
**HTTP_NOT_FOUND**

HTTP Status-Code 404: Not Found.
Constant Value: 404

#### public static final int
**HTTP_NOT_IMPLEMENTED**

HTTP Status-Code 501: Not Implemented.
Constant Value: 501

#### public static final int
**HTTP_NOT_MODIFIED**

HTTP Status-Code 304: Not Modified.
Constant Value: 304

#### public static final int
**HTTP_NO_CONTENT**

HTTP Status-Code 204: No Content.
Constant Value: 204

#### public static final int
**HTTP_OK**

HTTP Status-Code 200: OK.
Constant Value: 200

#### public static final int
**HTTP_PARTIAL**

HTTP Status-Code 206: Partial Content.
Constant Value: 206

#### public static final int
**HTTP_PAYMENT_REQUIRED**

HTTP Status-Code 402: Payment Required.
Constant Value: 402

#### public static final int
**HTTP_PRECON_FAILED**

HTTP Status-Code 412: Precondition Failed.
Constant Value: 412

#### public static final int
**HTTP_PROXY_AUTH**

HTTP Status-Code 407: Proxy Authentication Required.
Constant Value: 407

#### public static final int
**HTTP_REQ_TOO_LONG**

HTTP Status-Code 414: Request-URI Too Large.
Constant Value: 414

#### public static final int
**HTTP_RESET**

HTTP Status-Code 205: Reset Content.
Constant Value: 205

#### public static final int
**HTTP_SEE_OTHER**

HTTP Status-Code 303: See Other.
Constant Value: 303

#### public static final int
**HTTP_SERVER_ERROR**


**This constant is deprecated.**   
it is misplaced and shouldn't have existed.

HTTP Status-Code 500: Internal Server Error.
Constant Value: 500

#### public static final int
**HTTP_UNAUTHORIZED**

HTTP Status-Code 401: Unauthorized.
Constant Value: 401

#### public static final int
**HTTP_UNAVAILABLE**

HTTP Status-Code 503: Service Unavailable.
Constant Value: 503

#### public static final int
**HTTP_UNSUPPORTED_TYPE**

HTTP Status-Code 415: Unsupported Media Type.
Constant Value: 415

#### public static final int
**HTTP_USE_PROXY**

HTTP Status-Code 305: Use Proxy.
Constant Value: 305

#### public static final int
**HTTP_VERSION**

HTTP Status-Code 505: HTTP Version Not Supported.
Constant Value: 505

## Fields

#### protected int
**chunkLength**

The chunk-length when using chunked encoding streaming mode for output.
A value of `-1` means chunked encoding is disabled for output.

#### protected int
**fixedContentLength**

The fixed content-length when using fixed-length streaming mode.
A value of `-1` means fixed-length streaming mode is disabled
for output.

**NOTE:** `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#fixedContentLengthLong` is recommended instead
of this field, as it allows larger content lengths to be set.

#### protected long
**fixedContentLengthLong**

The fixed content-length when using fixed-length streaming mode.
A value of `-1` means fixed-length streaming mode is disabled
for output.

#### protected boolean
**instanceFollowRedirects**

If `true`, the protocol will automatically follow redirects.
If `false`, the protocol will not automatically follow
redirects.


This field is set by the `setInstanceFollowRedirects`
method. Its value is returned by the `getInstanceFollowRedirects`
method.


Its default value is based on the value of the static followRedirects
at HttpURLConnection construction time.

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setInstanceFollowRedirects(boolean)`
- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getInstanceFollowRedirects()`
- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFollowRedirects(boolean)`

#### protected [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)
**method**

The HTTP method (GET,POST,PUT,etc.).

#### protected int
**responseCode**

An `int` representing the three digit HTTP Status-Code.

- 1xx: Informational
- 2xx: Success
- 3xx: Redirection
- 4xx: Client Error
- 5xx: Server Error

<br />

#### protected [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)
**responseMessage**

The HTTP response message.

## Protected Constructors

#### protected
**HttpURLConnection**
([URL](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/URL.html) u)

Constructor for the HttpURLConnection.

##### Parameters

| u | the URL |
|---|---|

## Public Methods

#### public abstract void
**disconnect**
()

Indicates that other requests to the server
are unlikely in the near future. Calling disconnect()
should not imply that this HttpURLConnection
instance can be reused for other requests.

#### public [InputStream](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/InputStream.html)
**getErrorStream**
()

Returns the error stream if the connection failed
but the server sent useful data nonetheless. The
typical example is when an HTTP server responds
with a 404, which will cause a FileNotFoundException
to be thrown in connect, but the server sent an HTML
help page with suggestions as to what to do.

This method will not cause a connection to be initiated. If
the connection was not connected, or if the server did not have
an error while connecting or if the server had an error but
no error data was sent, this method will return null. This is
the default.

##### Returns

- an error stream if any, null if there have been no errors, the connection is not connected or the server sent no useful data.

#### public static boolean
**getFollowRedirects**
()

Returns a `boolean` indicating
whether or not HTTP redirects (3xx) should
be automatically followed.

##### Returns

- `true` if HTTP redirects should be automatically followed, `false` if not.

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFollowRedirects(boolean)`

#### public [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)
**getHeaderField**
(int n)

Returns the value for the `n`^th^ header field.
Some implementations may treat the `0`^th^
header field as special, i.e. as the status line returned by the HTTP
server.


This method can be used in conjunction with the
`https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getHeaderFieldKey(int)` method to iterate through all
the headers in the message.

##### Parameters

| n | an index, where n\>=0. |
|---|---|

##### Returns

- the value of the `n`^th^ header field, or `null` if the value does not exist.

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getHeaderFieldKey(int)`

#### public long
**getHeaderFieldDate**
([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) name, long Default)

Returns the value of the named field parsed as date.
The result is the number of milliseconds since January 1, 1970 GMT
represented by the named field.


This form of `getHeaderField` exists because some
connection types (e.g., `http-ng`) have pre-parsed
headers. Classes for that connection type can override this method
and short-circuit the parsing.

##### Parameters

| name | the name of the header field. |
| Default | a default value. |
|---|---|

##### Returns

- the value of the field, parsed as a date. The value of the `Default` argument is returned if the field is missing or malformed.

#### public [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)
**getHeaderFieldKey**
(int n)

Returns the key for the `n`^th^ header field.
Some implementations may treat the `0`^th^
header field as special, i.e. as the status line returned by the HTTP
server. In this case, `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getHeaderField(int)` returns the status
line, but `getHeaderFieldKey(0)` returns null.

##### Parameters

| n | an index, where n \>=0. |
|---|---|

##### Returns

- the key for the `n`^th^ header field, or `null` if the key does not exist.

#### public boolean
**getInstanceFollowRedirects**
()

Returns the value of this `HttpURLConnection`'s
`instanceFollowRedirects` field.

##### Returns

- the value of this `HttpURLConnection`'s `instanceFollowRedirects` field.

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#instanceFollowRedirects`
- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setInstanceFollowRedirects(boolean)`

#### public [Permission](https://developers.google.com/j2objc/javadoc/jre/reference/java/security/Permission.html)
**getPermission**
()

Returns a `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/SocketPermission.html` object representing the
permission necessary to connect to the destination host and port.

##### Returns

- a `SocketPermission` object representing the permission necessary to connect to the destination host and port.

##### Throws

| [IOException](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/IOException.html) | if an error occurs while computing the permission. |
|---|---|

#### public [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)
**getRequestMethod**
()

Get the request method.

##### Returns

- the HTTP request method

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setRequestMethod(java.lang.String)`

#### public int
**getResponseCode**
()

Gets the status code from an HTTP response message.
For example, in the case of the following status lines:

```
 HTTP/1.0 200 OK
 HTTP/1.0 401 Unauthorized
 
```
It will return 200 and 401 respectively. Returns -1 if no code can be discerned from the response (i.e., the response is not valid HTTP).

<br />

##### Returns

- the HTTP Status-Code, or -1

##### Throws

| [IOException](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/IOException.html) | if an error occurred connecting to the server. |
|---|---|

#### public [String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html)
**getResponseMessage**
()

Gets the HTTP response message, if any, returned along with the
response code from a server. From responses like:

```
 HTTP/1.0 200 OK
 HTTP/1.0 404 Not Found
 
```
Extracts the Strings "OK" and "Not Found" respectively. Returns null if none could be discerned from the responses (the result was not valid HTTP).

<br />

##### Returns

- the HTTP response message, or `null`

##### Throws

| [IOException](https://developers.google.com/j2objc/javadoc/jre/reference/java/io/IOException.html) | if an error occurred connecting to the server. |
|---|---|

#### public void
**setChunkedStreamingMode**
(int chunklen)

This method is used to enable streaming of a HTTP request body
without internal buffering, when the content length is **not**
known in advance. In this mode, chunked transfer encoding
is used to send the request body. Note, not all HTTP servers
support this mode.


When output streaming is enabled, authentication
and redirection cannot be handled automatically.
A HttpRetryException will be thrown when reading
the response if authentication or redirection are required.
This exception can be queried for the details of the error.


This method must be called before the URLConnection is connected.

##### Parameters

| chunklen | The number of bytes to write in each chunk. If chunklen is less than or equal to zero, a default value will be used. |
|---|---|

##### Throws

| [IllegalStateException](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/IllegalStateException.html) | if URLConnection is already connected or if a different streaming mode is already enabled. |
|---|---|

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFixedLengthStreamingMode(int)`

#### public void
**setFixedLengthStreamingMode**
(int contentLength)

This method is used to enable streaming of a HTTP request body
without internal buffering, when the content length is known in
advance.


An exception will be thrown if the application
attempts to write more data than the indicated
content-length, or if the application closes the OutputStream
before writing the indicated amount.


When output streaming is enabled, authentication
and redirection cannot be handled automatically.
A HttpRetryException will be thrown when reading
the response if authentication or redirection are required.
This exception can be queried for the details of the error.


This method must be called before the URLConnection is connected.


**NOTE:** `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFixedLengthStreamingMode(long)` is recommended
instead of this method as it allows larger content lengths to be set.

##### Parameters

| contentLength | The number of bytes which will be written to the OutputStream. |
|---|---|

##### Throws

| [IllegalStateException](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/IllegalStateException.html) | if URLConnection is already connected or if a different streaming mode is already enabled. |
| [IllegalArgumentException](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/IllegalArgumentException.html) | if a content length less than zero is specified. |
|---|---|

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setChunkedStreamingMode(int)`

#### public void
**setFixedLengthStreamingMode**
(long contentLength)

This method is used to enable streaming of a HTTP request body
without internal buffering, when the content length is known in
advance.

An exception will be thrown if the application attempts to write
more data than the indicated content-length, or if the application
closes the OutputStream before writing the indicated amount.

When output streaming is enabled, authentication and redirection
cannot be handled automatically. A {@linkplain HttpRetryException} will
be thrown when reading the response if authentication or redirection
are required. This exception can be queried for the details of the
error.

This method must be called before the URLConnection is connected.

The content length set by invoking this method takes precedence
over any value set by `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#setFixedLengthStreamingMode(int)`.

##### Parameters

| contentLength | The number of bytes which will be written to the OutputStream. |
|---|---|

##### Throws

| [IllegalStateException](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/IllegalStateException.html) | if URLConnection is already connected or if a different streaming mode is already enabled. |
| [IllegalArgumentException](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/IllegalArgumentException.html) | if a content length less than zero is specified. |
|---|---|

#### public static void
**setFollowRedirects**
(boolean set)

Sets whether HTTP redirects (requests with response code 3xx) should
be automatically followed by this class. True by default. Applets
cannot change this variable.


If there is a security manager, this method first calls
the security manager's `checkSetFactory` method
to ensure the operation is allowed.
This could result in a SecurityException.

##### Parameters

| set | a `boolean` indicating whether or not to follow HTTP redirects. |
|---|---|

##### Throws

| [SecurityException](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/SecurityException.html) | if a security manager exists and its `checkSetFactory` method doesn't allow the operation. |
|---|---|

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/SecurityManager.html#checkSetFactory()`
- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getFollowRedirects()`

#### public void
**setInstanceFollowRedirects**
(boolean followRedirects)

Sets whether HTTP redirects (requests with response code 3xx) should
be automatically followed by this `HttpURLConnection`
instance.


The default value comes from followRedirects, which defaults to
true.

##### Parameters

| followRedirects | a `boolean` indicating whether or not to follow HTTP redirects. |
|---|---|

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#instanceFollowRedirects`
- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getInstanceFollowRedirects()`

#### public void
**setRequestMethod**
([String](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/String.html) method)

Set the method for the URL request, one of:

- GET
- POST
- HEAD
- OPTIONS
- PUT
- DELETE
- TRACE

are legal, subject to protocol restrictions. The default method is GET.

<br />

##### Parameters

| method | the HTTP method |
|---|---|

##### Throws

| [ProtocolException](https://developers.google.com/j2objc/javadoc/jre/reference/java/net/ProtocolException.html) | if the method cannot be reset or if the requested method isn't valid for HTTP. |
| [SecurityException](https://developers.google.com/j2objc/javadoc/jre/reference/java/lang/SecurityException.html) | if a security manager is set and the method is "TRACE", but the "allowHttpTrace" NetPermission is not granted. |
|---|---|

##### See Also

- `https://developers.google.com/j2objc/javadoc/jre/reference/java/net/HttpURLConnection.html#getRequestMethod()`

#### public abstract boolean
**usingProxy**
()

Indicates if the connection is going through a proxy.

##### Returns

- a boolean indicating if the connection is using a proxy.